#pragma once

// BulletLink.h: Includes most basic bullet headers, and defines some convenient typedefs/wrappers/etc.

// Bullet v3 (https://github.com/bulletphysics/bullet3)
#include "../libsrc/bullet3-3.24/LinearMath/btVector3.h"
#include "../libsrc/bullet3-3.24/LinearMath/btMatrix3x3.h"

#include <ostream>

//  BulletPhysics Units (1m) to Unreal Units (2cm) conversion scale
#define BT_TO_UU (50.f)

// Unreal Units (2cm) to BulletPhysics Units (1m) conversion scale
#define UU_TO_BT (1.f/50.f)

// For printing btVector3
static inline std::ostream& operator <<(std::ostream& stream, const btVector3& v) {
	stream << "[ " << v.x() << ", " << v.y() << ", " << v.z() << " ]";
	return stream;
}

// Enum values for Bullet btCollisionObject userinfo usage
enum : int {
	BT_USERINFO_NONE,

	BT_USERINFO_TYPE_CAR,
	BT_USERINFO_TYPE_BALL
};
